<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc -->
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>BasicConfigurationBuilder (Apache Commons Configuration 2.2 API)</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="BasicConfigurationBuilder (Apache Commons Configuration 2.2 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10,"i20":10,"i21":10,"i22":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/BasicConfigurationBuilder.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/configuration2/builder/BasicBuilderProperties.html" title="interface in org.apache.commons.configuration2.builder"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/apache/commons/configuration2/builder/BuilderConfigurationWrapperFactory.html" title="class in org.apache.commons.configuration2.builder"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" target="_top">Frames</a></li>
<li><a href="BasicConfigurationBuilder.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.apache.commons.configuration2.builder</div>
<h2 title="Class BasicConfigurationBuilder" class="title">Class BasicConfigurationBuilder&lt;T extends <a href="../../../../../org/apache/commons/configuration2/ImmutableConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableConfiguration</a>&gt;</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>org.apache.commons.configuration2.builder.BasicConfigurationBuilder&lt;T&gt;</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the concrete type of <code>ImmutableConfiguration</code> objects created by this
        builder</dd>
</dl>
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../../../../../org/apache/commons/configuration2/builder/ConfigurationBuilder.html" title="interface in org.apache.commons.configuration2.builder">ConfigurationBuilder</a>&lt;T&gt;, <a href="../../../../../org/apache/commons/configuration2/event/EventSource.html" title="interface in org.apache.commons.configuration2.event">EventSource</a></dd>
</dl>
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><a href="../../../../../org/apache/commons/configuration2/builder/combined/CombinedConfigurationBuilder.html" title="class in org.apache.commons.configuration2.builder.combined">CombinedConfigurationBuilder</a>, <a href="../../../../../org/apache/commons/configuration2/builder/FileBasedConfigurationBuilder.html" title="class in org.apache.commons.configuration2.builder">FileBasedConfigurationBuilder</a>, <a href="../../../../../org/apache/commons/configuration2/builder/combined/MultiFileConfigurationBuilder.html" title="class in org.apache.commons.configuration2.builder.combined">MultiFileConfigurationBuilder</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">BasicConfigurationBuilder&lt;T extends <a href="../../../../../org/apache/commons/configuration2/ImmutableConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableConfiguration</a>&gt;</span>
extends <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>
implements <a href="../../../../../org/apache/commons/configuration2/builder/ConfigurationBuilder.html" title="interface in org.apache.commons.configuration2.builder">ConfigurationBuilder</a>&lt;T&gt;</pre>
<div class="block"><p>
 An implementation of the <code>ConfigurationBuilder</code> interface which is able
 to create different concrete <code>ImmutableConfiguration</code> implementations based on
 reflection.
 </p>
 <p>
 When constructing an instance of this class the concrete
 <code>ImmutableConfiguration</code> implementation class has to be provided. Then
 properties for the new <code>ImmutableConfiguration</code> instance can be set. The first
 call to <code>getConfiguration()</code> creates and initializes the new
 <code>ImmutableConfiguration</code> object. It is cached and returned by subsequent calls.
 This cache - and also the initialization properties set so far - can be
 flushed by calling one of the <code>reset()</code> methods. That way other
 <code>ImmutableConfiguration</code> instances with different properties can be created.
 </p>
 <p>
 If the newly created <code>ImmutableConfiguration</code> object implements the
 <code>Initializable</code> interface, its <code>initialize()</code> method is called
 after all initialization properties have been set. This way a concrete
 implementation class can perform arbitrary initialization steps.
 </p>
 <p>
 There are multiple options for setting up a <code>BasicConfigurationBuilder</code>
 instance:
 </p>
 <ul>
 <li>All initialization properties can be set in one or multiple calls of the
 <code>configure()</code> method. In each call an arbitrary number of
 <a href="../../../../../org/apache/commons/configuration2/builder/BuilderParameters.html" title="interface in org.apache.commons.configuration2.builder"><code>BuilderParameters</code></a> objects can be passed. The API allows method
 chaining and is intended to be used from Java code.</li>
 <li>If builder instances are created by other means - e.g. using a dependency
 injection framework -, the fluent API approach may not be suitable. For those
 use cases it is also possible to pass in all initialization parameters as a
 map. The keys of the map have to match initialization properties of the
 <code>ImmutableConfiguration</code> object to be created, the values are the corresponding
 property values. For instance, the key <em>throwExceptionOnMissing</em> in
 the map will cause the method <code>setThrowExceptionOnMissing()</code> on the
 <code>ImmutableConfiguration</code> object to be called with the corresponding value as
 parameter.</li>
 </ul>
 <p>
 A builder instance can be constructed with an <em>allowFailOnInit</em>
 flag. If set to <strong>true</strong>, exceptions during initialization
 of the configuration are ignored; in such a case an empty configuration
 object is returned. A use case for this flag is a scenario in which a
 configuration is optional and created on demand the first time configuration
 data is to be stored. Consider an application that stores user-specific
 configuration data in the user's home directory: When started for the first
 time by a new user there is no configuration file; so it makes sense to
 start with an empty configuration object. On application exit, settings
 can be stored in this object and written to the associated file. Then they
 are available on next application start.
 </p>
 <p>
 This class is thread-safe. Multiple threads can modify initialization
 properties and call <code>getConfiguration()</code>. However, the intended use
 case is that the builder is configured by a single thread first. Then
 <code>getConfiguration()</code> can be called concurrently, and it is guaranteed
 that always the same <code>ImmutableConfiguration</code> instance is returned until the
 builder is reset.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>2.0</dd>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>$Id: BasicConfigurationBuilder.java 1806681 2017-08-30 09:56:37Z kinow $</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#BasicConfigurationBuilder-java.lang.Class-">BasicConfigurationBuilder</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;&nbsp;resCls)</code>
<div class="block">Creates a new instance of <code>BasicConfigurationBuilder</code> and
 initializes it with the given result class.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#BasicConfigurationBuilder-java.lang.Class-java.util.Map-">BasicConfigurationBuilder</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;&nbsp;resCls,
                         <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;&nbsp;params)</code>
<div class="block">Creates a new instance of <code>BasicConfigurationBuilder</code> and
 initializes it with the given result class and an initial set of builder
 parameters.</div>
</td>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#BasicConfigurationBuilder-java.lang.Class-java.util.Map-boolean-">BasicConfigurationBuilder</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;&nbsp;resCls,
                         <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;&nbsp;params,
                         boolean&nbsp;allowFailOnInit)</code>
<div class="block">Creates a new instance of <code>BasicConfigurationBuilder</code> and
 initializes it with the given result class, an initial set of builder
 parameters, and the <em>allowFailOnInit</em> flag.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>&lt;E extends <a href="../../../../../org/apache/commons/configuration2/event/Event.html" title="class in org.apache.commons.configuration2.event">Event</a>&gt;<br>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#addEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">addEventListener</a></span>(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;E&gt;&nbsp;eventType,
                <a href="../../../../../org/apache/commons/configuration2/event/EventListener.html" title="interface in org.apache.commons.configuration2.event">EventListener</a>&lt;? super E&gt;&nbsp;listener)</code>
<div class="block">Adds an event listener for the specified event type.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="class in org.apache.commons.configuration2.builder">BasicConfigurationBuilder</a>&lt;<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#addParameters-java.util.Map-">addParameters</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;&nbsp;params)</code>
<div class="block">Adds the content of the given map to the already existing initialization
 parameters.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="class in org.apache.commons.configuration2.builder">BasicConfigurationBuilder</a>&lt;<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#configure-org.apache.commons.configuration2.builder.BuilderParameters...-">configure</a></span>(<a href="../../../../../org/apache/commons/configuration2/builder/BuilderParameters.html" title="interface in org.apache.commons.configuration2.builder">BuilderParameters</a>...&nbsp;params)</code>
<div class="block">Appends the content of the specified <code>BuilderParameters</code> objects to
 the current initialization parameters.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#connectToReloadingController-org.apache.commons.configuration2.reloading.ReloadingController-">connectToReloadingController</a></span>(<a href="../../../../../org/apache/commons/configuration2/reloading/ReloadingController.html" title="class in org.apache.commons.configuration2.reloading">ReloadingController</a>&nbsp;controller)</code>
<div class="block">Connects this builder with a <code>ReloadingController</code>.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#copyEventListeners-org.apache.commons.configuration2.builder.BasicConfigurationBuilder-">copyEventListeners</a></span>(<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="class in org.apache.commons.configuration2.builder">BasicConfigurationBuilder</a>&lt;?&gt;&nbsp;target)</code>
<div class="block">Copies all <code>EventListener</code> objects registered at this builder to
 the specified target configuration builder.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#copyEventListeners-org.apache.commons.configuration2.builder.BasicConfigurationBuilder-org.apache.commons.configuration2.event.EventListenerList-">copyEventListeners</a></span>(<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="class in org.apache.commons.configuration2.builder">BasicConfigurationBuilder</a>&lt;?&gt;&nbsp;target,
                  <a href="../../../../../org/apache/commons/configuration2/event/EventListenerList.html" title="class in org.apache.commons.configuration2.event">EventListenerList</a>&nbsp;listeners)</code>
<div class="block">Copies all event listeners in the specified list to the specified target
 configuration builder.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>protected <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#createResult--">createResult</a></span>()</code>
<div class="block">Creates a new, initialized result object.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>protected <a href="../../../../../org/apache/commons/configuration2/beanutils/BeanDeclaration.html" title="interface in org.apache.commons.configuration2.beanutils">BeanDeclaration</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#createResultDeclaration-java.util.Map-">createResultDeclaration</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;&nbsp;params)</code>
<div class="block">Creates a new <code>BeanDeclaration</code> which is used for creating new
 result objects dynamically.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>protected <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#createResultInstance--">createResultInstance</a></span>()</code>
<div class="block">Creates the new, uninitialized result object.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>protected <a href="../../../../../org/apache/commons/configuration2/beanutils/BeanHelper.html" title="class in org.apache.commons.configuration2.beanutils">BeanHelper</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#fetchBeanHelper--">fetchBeanHelper</a></span>()</code>
<div class="block">Obtains the <code>BeanHelper</code> object to be used when dealing with bean
 declarations.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#fireBuilderEvent-org.apache.commons.configuration2.builder.ConfigurationBuilderEvent-">fireBuilderEvent</a></span>(<a href="../../../../../org/apache/commons/configuration2/builder/ConfigurationBuilderEvent.html" title="class in org.apache.commons.configuration2.builder">ConfigurationBuilderEvent</a>&nbsp;event)</code>
<div class="block">Sends the specified builder event to all registered listeners.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#getConfiguration--">getConfiguration</a></span>()</code>
<div class="block">Returns the configuration provided by this builder.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>protected <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#getParameters--">getParameters</a></span>()</code>
<div class="block">Returns a (unmodifiable) map with the current initialization parameters
 set for this builder.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#getResultClass--">getResultClass</a></span>()</code>
<div class="block">Returns the result class of this builder.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>protected <a href="../../../../../org/apache/commons/configuration2/beanutils/BeanDeclaration.html" title="interface in org.apache.commons.configuration2.beanutils">BeanDeclaration</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#getResultDeclaration--">getResultDeclaration</a></span>()</code>
<div class="block">Returns the <code>BeanDeclaration</code> that is used to create and initialize
 result objects.</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#initResultInstance-T-">initResultInstance</a></span>(<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&nbsp;obj)</code>
<div class="block">Initializes a newly created result object.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>protected &lt;E extends <a href="../../../../../org/apache/commons/configuration2/event/Event.html" title="class in org.apache.commons.configuration2.event">Event</a>&gt;<br>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#installEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">installEventListener</a></span>(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;E&gt;&nbsp;eventType,
                    <a href="../../../../../org/apache/commons/configuration2/event/EventListener.html" title="interface in org.apache.commons.configuration2.event">EventListener</a>&lt;? super E&gt;&nbsp;listener)</code>
<div class="block">Adds the specified event listener to this object.</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#isAllowFailOnInit--">isAllowFailOnInit</a></span>()</code>
<div class="block">Returns the <em>allowFailOnInit</em> flag.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>&lt;E extends <a href="../../../../../org/apache/commons/configuration2/event/Event.html" title="class in org.apache.commons.configuration2.event">Event</a>&gt;<br>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#removeEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">removeEventListener</a></span>(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;E&gt;&nbsp;eventType,
                   <a href="../../../../../org/apache/commons/configuration2/event/EventListener.html" title="interface in org.apache.commons.configuration2.event">EventListener</a>&lt;? super E&gt;&nbsp;listener)</code>
<div class="block">Removes the event listener registration for the given event type and
 listener.</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#reset--">reset</a></span>()</code>
<div class="block">Resets this builder.</div>
</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#resetParameters--">resetParameters</a></span>()</code>
<div class="block">Removes all initialization parameters of this builder.</div>
</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#resetResult--">resetResult</a></span>()</code>
<div class="block">Clears an existing result object.</div>
</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="class in org.apache.commons.configuration2.builder">BasicConfigurationBuilder</a>&lt;<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#setParameters-java.util.Map-">setParameters</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;&nbsp;params)</code>
<div class="block">Sets the initialization parameters of this builder.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="BasicConfigurationBuilder-java.lang.Class-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>BasicConfigurationBuilder</h4>
<pre>public&nbsp;BasicConfigurationBuilder(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;&nbsp;resCls)</pre>
<div class="block">Creates a new instance of <code>BasicConfigurationBuilder</code> and
 initializes it with the given result class. No initialization properties
 are set.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>resCls</code> - the result class (must not be <b>null</b>)</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the result class is <b>null</b></dd>
</dl>
</li>
</ul>
<a name="BasicConfigurationBuilder-java.lang.Class-java.util.Map-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>BasicConfigurationBuilder</h4>
<pre>public&nbsp;BasicConfigurationBuilder(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;&nbsp;resCls,
                                 <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;&nbsp;params)</pre>
<div class="block">Creates a new instance of <code>BasicConfigurationBuilder</code> and
 initializes it with the given result class and an initial set of builder
 parameters. The <em>allowFailOnInit</em> flag is set to
 <strong>false</strong>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>resCls</code> - the result class (must not be <b>null</b>)</dd>
<dd><code>params</code> - a map with initialization parameters</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the result class is <b>null</b></dd>
</dl>
</li>
</ul>
<a name="BasicConfigurationBuilder-java.lang.Class-java.util.Map-boolean-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>BasicConfigurationBuilder</h4>
<pre>public&nbsp;BasicConfigurationBuilder(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;&nbsp;resCls,
                                 <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;&nbsp;params,
                                 boolean&nbsp;allowFailOnInit)</pre>
<div class="block">Creates a new instance of <code>BasicConfigurationBuilder</code> and
 initializes it with the given result class, an initial set of builder
 parameters, and the <em>allowFailOnInit</em> flag. The map with
 parameters may be <b>null</b>, in this case no initialization parameters
 are set.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>resCls</code> - the result class (must not be <b>null</b>)</dd>
<dd><code>params</code> - a map with initialization parameters</dd>
<dd><code>allowFailOnInit</code> - a flag whether exceptions on initializing a newly
        created <code>ImmutableConfiguration</code> object are allowed</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the result class is <b>null</b></dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getResultClass--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getResultClass</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;&nbsp;getResultClass()</pre>
<div class="block">Returns the result class of this builder. The objects produced by this
 builder have the class returned here.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the result class of this builder</dd>
</dl>
</li>
</ul>
<a name="isAllowFailOnInit--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isAllowFailOnInit</h4>
<pre>public&nbsp;boolean&nbsp;isAllowFailOnInit()</pre>
<div class="block">Returns the <em>allowFailOnInit</em> flag. See the header comment for
 information about this flag.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the <em>allowFailOnInit</em> flag</dd>
</dl>
</li>
</ul>
<a name="setParameters-java.util.Map-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setParameters</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="class in org.apache.commons.configuration2.builder">BasicConfigurationBuilder</a>&lt;<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;&nbsp;setParameters(<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;&nbsp;params)</pre>
<div class="block">Sets the initialization parameters of this builder. Already existing
 parameters are replaced by the content of the given map.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>params</code> - the new initialization parameters of this builder; can be
        <b>null</b>, then all initialization parameters are removed</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a reference to this builder for method chaining</dd>
</dl>
</li>
</ul>
<a name="addParameters-java.util.Map-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addParameters</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="class in org.apache.commons.configuration2.builder">BasicConfigurationBuilder</a>&lt;<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;&nbsp;addParameters(<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;&nbsp;params)</pre>
<div class="block">Adds the content of the given map to the already existing initialization
 parameters.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>params</code> - the map with additional initialization parameters; may be
        <b>null</b>, then this call has no effect</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a reference to this builder for method chaining</dd>
</dl>
</li>
</ul>
<a name="configure-org.apache.commons.configuration2.builder.BuilderParameters...-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>configure</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="class in org.apache.commons.configuration2.builder">BasicConfigurationBuilder</a>&lt;<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&gt;&nbsp;configure(<a href="../../../../../org/apache/commons/configuration2/builder/BuilderParameters.html" title="interface in org.apache.commons.configuration2.builder">BuilderParameters</a>...&nbsp;params)</pre>
<div class="block">Appends the content of the specified <code>BuilderParameters</code> objects to
 the current initialization parameters. Calling this method multiple times
 will create a union of the parameters provided.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>params</code> - an arbitrary number of objects with builder parameters</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a reference to this builder for method chaining</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/NullPointerException.html?is-external=true" title="class or interface in java.lang">NullPointerException</a></code> - if a <b>null</b> array is passed</dd>
</dl>
</li>
</ul>
<a name="getConfiguration--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getConfiguration</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&nbsp;getConfiguration()
                   throws <a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationException</a></pre>
<div class="block">Returns the configuration provided by this builder. An implementation has
 to perform all necessary steps for creating and initializing a
 <code>ImmutableConfiguration</code> object. This implementation creates the result configuration on
 first access. Later invocations return the same object until this builder
 is reset. The double-check idiom for lazy initialization is used (Bloch,
 Effective Java, item 71).</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/builder/ConfigurationBuilder.html#getConfiguration--">getConfiguration</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/builder/ConfigurationBuilder.html" title="interface in org.apache.commons.configuration2.builder">ConfigurationBuilder</a>&lt;<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a> extends <a href="../../../../../org/apache/commons/configuration2/ImmutableConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableConfiguration</a>&gt;</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the configuration</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationException</a></code> - if an error occurs</dd>
</dl>
</li>
</ul>
<a name="addEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addEventListener</h4>
<pre>public&nbsp;&lt;E extends <a href="../../../../../org/apache/commons/configuration2/event/Event.html" title="class in org.apache.commons.configuration2.event">Event</a>&gt;&nbsp;void&nbsp;addEventListener(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;E&gt;&nbsp;eventType,
                                               <a href="../../../../../org/apache/commons/configuration2/event/EventListener.html" title="interface in org.apache.commons.configuration2.event">EventListener</a>&lt;? super E&gt;&nbsp;listener)</pre>
<div class="block">Adds an event listener for the specified event type. This listener is
 notified about events of this type and all its sub types. This implementation also takes care that the event listener
 is added to the managed configuration object.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/event/EventSource.html#addEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">addEventListener</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/event/EventSource.html" title="interface in org.apache.commons.configuration2.event">EventSource</a></code></dd>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>E</code> - the type of events processed by this listener</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>eventType</code> - the event type (must not be <b>null</b>)</dd>
<dd><code>listener</code> - the listener to be registered (must not be <b>null</b>)</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the event type or the listener is
         <b>null</b></dd>
</dl>
</li>
</ul>
<a name="removeEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeEventListener</h4>
<pre>public&nbsp;&lt;E extends <a href="../../../../../org/apache/commons/configuration2/event/Event.html" title="class in org.apache.commons.configuration2.event">Event</a>&gt;&nbsp;boolean&nbsp;removeEventListener(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;E&gt;&nbsp;eventType,
                                                     <a href="../../../../../org/apache/commons/configuration2/event/EventListener.html" title="interface in org.apache.commons.configuration2.event">EventListener</a>&lt;? super E&gt;&nbsp;listener)</pre>
<div class="block">Removes the event listener registration for the given event type and
 listener. An event listener instance may be registered multiple times for
 different event types. Therefore, when removing a listener the event type
 of the registration in question has to be specified. The return value
 indicates whether a registration was removed. A value of <b>false</b>
 means that no such combination of event type and listener was found. This implementation also takes care that the event listener
 is removed from the managed configuration object.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/event/EventSource.html#removeEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">removeEventListener</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/event/EventSource.html" title="interface in org.apache.commons.configuration2.event">EventSource</a></code></dd>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>E</code> - the type of events processed by this listener</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>eventType</code> - the event type</dd>
<dd><code>listener</code> - the event listener to be removed</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a flag whether a listener registration was removed</dd>
</dl>
</li>
</ul>
<a name="resetResult--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>resetResult</h4>
<pre>public&nbsp;void&nbsp;resetResult()</pre>
<div class="block">Clears an existing result object. An invocation of this method causes a
 new <code>ImmutableConfiguration</code> object to be created the next time
 <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#getConfiguration--"><code>getConfiguration()</code></a> is called.</div>
</li>
</ul>
<a name="resetParameters--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>resetParameters</h4>
<pre>public&nbsp;void&nbsp;resetParameters()</pre>
<div class="block">Removes all initialization parameters of this builder. This method can be
 called if this builder is to be reused for creating result objects with a
 different configuration.</div>
</li>
</ul>
<a name="reset--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>reset</h4>
<pre>public&nbsp;void&nbsp;reset()</pre>
<div class="block">Resets this builder. This is a convenience method which combines calls to
 <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#resetResult--"><code>resetResult()</code></a> and <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#resetParameters--"><code>resetParameters()</code></a>.</div>
</li>
</ul>
<a name="connectToReloadingController-org.apache.commons.configuration2.reloading.ReloadingController-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>connectToReloadingController</h4>
<pre>public final&nbsp;void&nbsp;connectToReloadingController(<a href="../../../../../org/apache/commons/configuration2/reloading/ReloadingController.html" title="class in org.apache.commons.configuration2.reloading">ReloadingController</a>&nbsp;controller)</pre>
<div class="block">Connects this builder with a <code>ReloadingController</code>. With this
 method support for reloading can be added to an arbitrary builder object.
 Event listeners are registered at the reloading controller and this
 builder with connect both objects:
 <ul>
 <li>When the reloading controller detects that a reload is required, the
 builder's <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#resetResult--"><code>resetResult()</code></a> method is called; so the managed result
 object is invalidated.</li>
 <li>When a new result object has been created the controller's reloading
 state is reset, so that new changes can be detected again.</li>
 </ul></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>controller</code> - the <code>ReloadingController</code> to connect to (must not
        be <b>null</b>)</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the controller is <b>null</b></dd>
</dl>
</li>
</ul>
<a name="createResult--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createResult</h4>
<pre>protected&nbsp;<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&nbsp;createResult()
                  throws <a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationException</a></pre>
<div class="block">Creates a new, initialized result object. This method is called by
 <code>getConfiguration()</code> if no valid result object exists. This base
 implementation performs two steps:
 <ul>
 <li><code>createResultInstance()</code> is called to create a new,
 uninitialized result object.</li>
 <li><code>initResultInstance()</code> is called to process all initialization
 parameters.</li>
 </ul>
 It also evaluates the <em>allowFailOnInit</em> flag, i.e. if
 initialization causes an exception and this flag is set, the exception is
 ignored, and the newly created, uninitialized configuration is returned.
 Note that this method is called in a synchronized block.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the newly created result object</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationException</a></code> - if an error occurs</dd>
</dl>
</li>
</ul>
<a name="createResultInstance--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createResultInstance</h4>
<pre>protected&nbsp;<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&nbsp;createResultInstance()
                          throws <a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationException</a></pre>
<div class="block">Creates the new, uninitialized result object. This is the first step of
 the process of producing a result object for this builder. This
 implementation uses the <a href="../../../../../org/apache/commons/configuration2/beanutils/BeanHelper.html" title="class in org.apache.commons.configuration2.beanutils"><code>BeanHelper</code></a> class to create a new object
 based on the <a href="../../../../../org/apache/commons/configuration2/beanutils/BeanDeclaration.html" title="interface in org.apache.commons.configuration2.beanutils"><code>BeanDeclaration</code></a> returned by
 <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#getResultDeclaration--"><code>getResultDeclaration()</code></a>. Note: This method is invoked in a
 synchronized block.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the newly created, yet uninitialized result object</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationException</a></code> - if an exception occurs</dd>
</dl>
</li>
</ul>
<a name="initResultInstance-org.apache.commons.configuration2.ImmutableConfiguration-">
<!--   -->
</a><a name="initResultInstance-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>initResultInstance</h4>
<pre>protected&nbsp;void&nbsp;initResultInstance(<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="type parameter in BasicConfigurationBuilder">T</a>&nbsp;obj)
                           throws <a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationException</a></pre>
<div class="block">Initializes a newly created result object. This is the second step of the
 process of producing a result object for this builder. This
 implementation uses the <a href="../../../../../org/apache/commons/configuration2/beanutils/BeanHelper.html" title="class in org.apache.commons.configuration2.beanutils"><code>BeanHelper</code></a> class to initialize the
 object's property based on the <a href="../../../../../org/apache/commons/configuration2/beanutils/BeanDeclaration.html" title="interface in org.apache.commons.configuration2.beanutils"><code>BeanDeclaration</code></a> returned by
 <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#getResultDeclaration--"><code>getResultDeclaration()</code></a>. Note: This method is invoked in a
 synchronized block. This is required because internal state is accessed.
 Sub classes must not call this method without proper synchronization.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>obj</code> - the object to be initialized</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationException</a></code> - if an error occurs</dd>
</dl>
</li>
</ul>
<a name="getResultDeclaration--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getResultDeclaration</h4>
<pre>protected final&nbsp;<a href="../../../../../org/apache/commons/configuration2/beanutils/BeanDeclaration.html" title="interface in org.apache.commons.configuration2.beanutils">BeanDeclaration</a>&nbsp;getResultDeclaration()
                                              throws <a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationException</a></pre>
<div class="block">Returns the <code>BeanDeclaration</code> that is used to create and initialize
 result objects. The declaration is created on first access (by invoking
 <a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html#createResultDeclaration-java.util.Map-"><code>createResultDeclaration(Map)</code></a>) based on the current
 initialization parameters.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the <code>BeanDeclaration</code> for dynamically creating a result
         object</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationException</a></code> - if an error occurs</dd>
</dl>
</li>
</ul>
<a name="getParameters--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getParameters</h4>
<pre>protected final&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;&nbsp;getParameters()</pre>
<div class="block">Returns a (unmodifiable) map with the current initialization parameters
 set for this builder. The map is populated with the parameters set using
 the various configuration options.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a map with the current set of initialization parameters</dd>
</dl>
</li>
</ul>
<a name="fetchBeanHelper--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>fetchBeanHelper</h4>
<pre>protected final&nbsp;<a href="../../../../../org/apache/commons/configuration2/beanutils/BeanHelper.html" title="class in org.apache.commons.configuration2.beanutils">BeanHelper</a>&nbsp;fetchBeanHelper()</pre>
<div class="block">Obtains the <code>BeanHelper</code> object to be used when dealing with bean
 declarations. This method checks whether this builder was configured with
 a specific <code>BeanHelper</code> instance. If so, this instance is used.
 Otherwise, the default <code>BeanHelper</code> is returned.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the <code>BeanHelper</code> to be used</dd>
</dl>
</li>
</ul>
<a name="createResultDeclaration-java.util.Map-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createResultDeclaration</h4>
<pre>protected&nbsp;<a href="../../../../../org/apache/commons/configuration2/beanutils/BeanDeclaration.html" title="interface in org.apache.commons.configuration2.beanutils">BeanDeclaration</a>&nbsp;createResultDeclaration(<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;&nbsp;params)
                                           throws <a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationException</a></pre>
<div class="block">Creates a new <code>BeanDeclaration</code> which is used for creating new
 result objects dynamically. This implementation creates a specialized
 <code>BeanDeclaration</code> object that is initialized from the given map of
 initialization parameters. The <code>BeanDeclaration</code> must be
 initialized with the result class of this builder, otherwise exceptions
 will be thrown when the result object is created. Note: This method is
 invoked in a synchronized block.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>params</code> - a snapshot of the current initialization parameters</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the <code>BeanDeclaration</code> for creating result objects</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationException</a></code> - if an error occurs</dd>
</dl>
</li>
</ul>
<a name="copyEventListeners-org.apache.commons.configuration2.builder.BasicConfigurationBuilder-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>copyEventListeners</h4>
<pre>protected&nbsp;void&nbsp;copyEventListeners(<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="class in org.apache.commons.configuration2.builder">BasicConfigurationBuilder</a>&lt;?&gt;&nbsp;target)</pre>
<div class="block">Copies all <code>EventListener</code> objects registered at this builder to
 the specified target configuration builder. This method is intended to be
 used by derived classes which support inheritance of their properties to
 other builder objects.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>target</code> - the target configuration builder (must not be <b>null</b>)</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/NullPointerException.html?is-external=true" title="class or interface in java.lang">NullPointerException</a></code> - if the target builder is <b>null</b></dd>
</dl>
</li>
</ul>
<a name="copyEventListeners-org.apache.commons.configuration2.builder.BasicConfigurationBuilder-org.apache.commons.configuration2.event.EventListenerList-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>copyEventListeners</h4>
<pre>protected&nbsp;void&nbsp;copyEventListeners(<a href="../../../../../org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" title="class in org.apache.commons.configuration2.builder">BasicConfigurationBuilder</a>&lt;?&gt;&nbsp;target,
                                  <a href="../../../../../org/apache/commons/configuration2/event/EventListenerList.html" title="class in org.apache.commons.configuration2.event">EventListenerList</a>&nbsp;listeners)</pre>
<div class="block">Copies all event listeners in the specified list to the specified target
 configuration builder. This method is intended to be used by derived
 classes which have to deal with managed configuration builders that need
 to be initialized with event listeners.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>target</code> - the target configuration builder (must not be <b>null</b>)</dd>
<dd><code>listeners</code> - the event listeners to be copied over</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/NullPointerException.html?is-external=true" title="class or interface in java.lang">NullPointerException</a></code> - if the target builder is <b>null</b></dd>
</dl>
</li>
</ul>
<a name="installEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>installEventListener</h4>
<pre>protected final&nbsp;&lt;E extends <a href="../../../../../org/apache/commons/configuration2/event/Event.html" title="class in org.apache.commons.configuration2.event">Event</a>&gt;&nbsp;void&nbsp;installEventListener(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;E&gt;&nbsp;eventType,
                                                            <a href="../../../../../org/apache/commons/configuration2/event/EventListener.html" title="interface in org.apache.commons.configuration2.event">EventListener</a>&lt;? super E&gt;&nbsp;listener)</pre>
<div class="block">Adds the specified event listener to this object. This method is called
 by <code>addEventListener()</code>, it does the actual listener registration.
 Because it is final it can be called by sub classes in the constructor if
 there is already the need to register an event listener.</div>
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>E</code> - the event type</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>eventType</code> - the event type object</dd>
<dd><code>listener</code> - the listener to be registered</dd>
</dl>
</li>
</ul>
<a name="fireBuilderEvent-org.apache.commons.configuration2.builder.ConfigurationBuilderEvent-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>fireBuilderEvent</h4>
<pre>protected&nbsp;void&nbsp;fireBuilderEvent(<a href="../../../../../org/apache/commons/configuration2/builder/ConfigurationBuilderEvent.html" title="class in org.apache.commons.configuration2.builder">ConfigurationBuilderEvent</a>&nbsp;event)</pre>
<div class="block">Sends the specified builder event to all registered listeners.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>event</code> - the event to be fired</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/BasicConfigurationBuilder.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/configuration2/builder/BasicBuilderProperties.html" title="interface in org.apache.commons.configuration2.builder"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/apache/commons/configuration2/builder/BuilderConfigurationWrapperFactory.html" title="class in org.apache.commons.configuration2.builder"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/builder/BasicConfigurationBuilder.html" target="_top">Frames</a></li>
<li><a href="BasicConfigurationBuilder.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &#169; 2001&#x2013;2017 <a href="https://www.apache.org/">The Apache Software Foundation</a>. All rights reserved.</small></p>
</body>
</html>
